##PROJECT_GLOBAL_BEGIN
[Programs]
Count=1

[Misc Info]
Author=
Company=
Version=
EditTime=5433
CyProVersion=3.2.3

[Protection]
Level=0
Password=
##PROJECT_GLOBAL_END

##PROGRAM_BEGIN_1
#PROJECT_OPTIONS_BEGIN
[Program]
Name=Charger

[VCP]
I2CPriority=5
SendSource=1
SendAlloc=1
ProtectWithPasswd=0
Password=
ScanOverrunStopsProgram=1
OutputRetentive=0
AutoStart=1
Com1Mode=3
Com1Baudrate=2
Com1Data=0
Com2Mode=3
Com2Baudrate=2
Com2Data=0
EthAbusEnable=1
EthModbusEnable=0
WANUrl=
PushEvent=0
PushUrl=
ModbusDelay=20
ModbusDeviceAddress=1
ModbusPLCDataModel=2
ModbusAddress=0
ModbusRegisterCount=1
ModbusCoilsArrayVar=
ModbusRegistersArrayVar=
PLCCoilVars=
PLCRegisterVars=
ModbusCoilAddresses=
ModbusRegisterAddresses=

[Misc Info]
MonitorHistorySpeed=10

[Hardware]
CPUUnit=10
VarAreaTyp0.7.0=0
VarAreaTyp0.7.1=0
VarAreaTyp0.7.2=0
VarAreaTyp0.7.3=0
VarAreaTyp0.7.4=0
VarAreaTyp0.7.5=0

[Socket00]
ID=1
SocketType=0
Descr=Request to send socket for testing device
Var00=socket_req

[Socket01]
ID=2
SocketType=4
Descr=Socket to send to testing device
Var00=socket_req
Var01=cybro_nad
Var02=cybro_hardware_id
Var03=program_id
Var04=program_version
Var05=cybro_hardware_error
Var06=rcd_sensor_error
Var07=internal_detected
Var08=cybro_power_supply
Var09=cybro_temperature
Var10=control_pilot_positive
Var11=control_pilot_negative
Var12=output_contactor
Var13=internal_current_L1
Var14=internal_current_L2
Var15=internal_current_L3
Var16=house_detected
Var17=solar_detected
Var18=relay_detected
Var19=pulse_train_frequency
Var20=pulse_train_frequency
Var21=pulse_train_frequency
Var22=pulse_train_frequency
Var23=pulse_train_frequency

[Net]
CurrentNAD=-1

[Monitor01]
VarCount=7
VarName1=socket_req
VarBase1=1
VarValue1=0
VarColor1=0
VarIndex1=0
VarName2=internal_current_L1
VarBase2=1
VarValue2=0
VarColor2=0
VarIndex2=1
VarName3=internal_current_L2
VarBase3=1
VarValue3=0
VarColor3=0
VarIndex3=2
VarName4=internal_current_L3
VarBase4=1
VarValue4=0
VarColor4=0
VarIndex4=3
VarName5=internal_voltage_L1
VarBase5=1
VarValue5=0
VarColor5=0
VarIndex5=4
VarName6=internal_voltage_L2
VarBase6=1
VarValue6=0
VarColor6=0
VarIndex6=5
VarName7=internal_voltage_L3
VarBase7=1
VarValue7=0
VarColor7=0
VarIndex7=6
#PROJECT_OPTIONS_END

#DMVARSLIST_BEGIN
#DMVARSLIST_END

#MASKS_BEGIN
#MASKS_END

#CODE_BEGIN
// AllocGroupList="User variables", "Device driver", "Charge driver", "Power meter", "RFID system", "Event logger", "Cybro system", "Configuration", "Constants", "I/O Variables"
var retain
  reset_counter: long; // Total number of on/off cycles. Press and hold to reset (pos=204, name="Reset counter"). {AllocGroup="Cybro system", scada}
  operating_hours: long; // Total number of operating hours [h]. {AllocGroup="Cybro system"}
  event_start_year: ARRAY[0..9] OF int; // Event start date. {AllocGroup="Event logger"}
  event_start_month: ARRAY[0..9] OF int; // Event start date. {AllocGroup="Event logger"}
  event_start_date: ARRAY[0..9] OF int; // Event start date. {AllocGroup="Event logger"}
  event_start_hour: ARRAY[0..9] OF int; // Event start time [hh.mm]. {AllocGroup="Event logger"}
  event_start_min: ARRAY[0..9] OF int; // Event start time [hh.mm]. {AllocGroup="Event logger"}
  event_stop_hour: ARRAY[0..9] OF int; // Event stop time [hh.mm]. {AllocGroup="Event logger"}
  event_stop_min: ARRAY[0..9] OF int; // Event stop time [hh.mm]. {AllocGroup="Event logger"}
  event_duration: ARRAY[0..9] OF int; // Event duration [min]. {AllocGroup="Event logger"}
  event_type: ARRAY[0..9] OF int; // Event type: 0-none, 1-charging cycle, +2-error code. {AllocGroup="Event logger"}
  event_card: ARRAY[0..9] OF int; // Card used to unlock the charger (0-none, 1..4, 99 is PC). {AllocGroup="Event logger"}
  event_number: ARRAY[0..9] OF int; // Charging cycle number. {AllocGroup="Event logger"}
  event_energy: ARRAY[0..9] OF int; // Charging energy. {AllocGroup="Event logger"}
  event_average: ARRAY[0..9] OF int; // Average current. {AllocGroup="Event logger"}
  charging_cycle_count: int; // Total number of charging cycles. {AllocGroup="Event logger"}
var_end;

var permanent
  power_grid_limit: int; // The maximum current that charger can draw from the grid [0.1A] (pos=310, name="Power grid limit", unit=A, dec=1, action=7, spacer="General settings"). {AllocGroup="Configuration", scada}
  economy_current_limit: int; // The maximum current in the economy profile [0.1A]. Zero means no limit (pos=301, name="Economy limit", unit=A, dec=1, action=7). {AllocGroup="Configuration", scada}
  economy_start_hour: int; // Time when the low rate electricity begins. 00:00 means no limit (pos=302, name="Economy start time", unit=hour, max=23, action=6). {AllocGroup="Configuration", scada}
  economy_start_min: int; // Time when the low rate electricity begins. 00:00 means no limit (pos=303, name="Economy start time", unit=min, max=55, step=5, action=6). {AllocGroup="Configuration", scada}
  economy_stop_hour: int; // Time when the low rate electricity ends (pos=304, name="Economy stop time", unit=hour, max=23, action=6). {AllocGroup="Configuration", scada}
  economy_stop_min: int; // Time when the low rate electricity ends (pos=305, name="Economy stop time", unit=min, max=55, step=5, action=6). {AllocGroup="Configuration", scada}
  priority_duration: int; // The time after which the charger switches back from priority to economy profile [min]. Zero means no limit (pos=300, name="Priority duration", unit=min, action=7, spacer="Charging profile"). {AllocGroup="Configuration", scada}
  overvoltage_limit: int; // Upper limit for the power supply voltage [V]. Zero means no limit (pos=311, name="Overvoltage limit", unit=V, action=7). {AllocGroup="Configuration", scada}
  undervoltage_limit: int; // Lower limit for the power supply voltage [V]. Zero means no limit (pos=312, name="Undervoltage limit", unit=V, action=7). {AllocGroup="Configuration", scada}
  ventilation_available: bool; // Accept request for charging with ventilation (pos=313, name="Charging with ventilation", icon=12, action=2). {AllocGroup="Configuration", scada}
  fast_wireless_cycle: bool; // Enable fast wireless communication (0-10s, 1-1s). Enable when power limiter trips with sudden increase in consumption (pos=314, name="Fast wireless cycle", icon=12, action=2). {AllocGroup="Configuration", scada}
  rfid_enable: bool; // When enabled, charger must be unlocked with rfid card before charging (pos=340, name="Enable", icon=12, action=2, spacer="RFID system"). {AllocGroup="Configuration", scada}
  rfid_card: ARRAY[0..3] OF long; // Cards configured to unlock the charger. {AllocGroup="Configuration"}
  group_address: long; // Currently configured wireless group address (pos=332, name="Group address"). {AllocGroup="Configuration", scada}
  ee_integrity_magic: long; // Press and hold to restore factory defaults (pos=399, name="Reset all", list=" ", action=5, spacer="Factory reset"). {AllocGroup="Configuration", scada}
var_end;

var constant
  OFF = 0; // {AllocGroup="Constants"}
  ON = 1; // {AllocGroup="Constants"}
  PWM_OFF = 0; // pwm_control {AllocGroup="Constants"}
  PWM_ON = 1; // pwm_control {AllocGroup="Constants"}
  PWM_ERR = 2; // pwm_control {AllocGroup="Constants"}
  CP12V = 0; // control_pilot_status {AllocGroup="Constants"}
  CP9V = 1; // control_pilot_status {AllocGroup="Constants"}
  CP6V = 2; // control_pilot_status {AllocGroup="Constants"}
  CP3V = 3; // control_pilot_status {AllocGroup="Constants"}
  CP0V = 4; // control_pilot_status {AllocGroup="Constants"}
  SLOCKED = 0; // charger_state {AllocGroup="Constants"}
  SSTANDBY = 1; // charger_state {AllocGroup="Constants"}
  SCONNECT = 2; // charger_state {AllocGroup="Constants"}
  SSTARTING = 3; // charger_state {AllocGroup="Constants"}
  SSTOPPING = 4; // charger_state {AllocGroup="Constants"}
  SCHARGING = 5; // charger_state {AllocGroup="Constants"}
  SERROR = 6; // charger_state {AllocGroup="Constants"}
  ERRPOS = 2; // error_code {AllocGroup="Constants"}
  ERRNEG = 3; // error_code {AllocGroup="Constants"}
  ERRRCD = 4; // error_code {AllocGroup="Constants"}
  ERROVER = 5; // error_code {AllocGroup="Constants"}
  ERRUNDER = 6; // error_code {AllocGroup="Constants"}
  ERRVENT = 7; // error_code {AllocGroup="Constants"}
  CRED = 1; // led_indicator {AllocGroup="Constants"}
  CGREEN = 2; // led_indicator {AllocGroup="Constants"}
  CYELLOW = 3; // led_indicator {AllocGroup="Constants"}
  CBLUE = 4; // led_indicator {AllocGroup="Constants"}
  CPURPLE = 5; // led_indicator {AllocGroup="Constants"}
  CCYAN = 6; // led_indicator {AllocGroup="Constants"}
  CWHITE = 7; // led_indicator {AllocGroup="Constants"}
  BFAST = 1; // led_blinking {AllocGroup="Constants"}
  BSLOW = 2; // led_blinking {AllocGroup="Constants"}
  BASYM = 3; // led_blinking {AllocGroup="Constants"}
  NOCARDS = 4; // The maximum number of stored RFID cards. {AllocGroup="Constants"}
var_end;

var
  pwm_control: int; // PWM output control: 0-stop pwm (+12V), 1-start pwm, 2-error (-12V). {AllocGroup="Charge driver"}
  pwm_output: int; // PWM output value (0..100%) (pos=212, name="Control pilot PWM", unit=%). {AllocGroup="Charge driver", scada}
  control_pilot_positive: int; // Voltage on CP terminal, positive period, corrected for voltage drop on schottky diode [0.1V] (pos=210, name="Control pilot positive", unit=V, dec=1). {AllocGroup="Charge driver", scada}
  control_pilot_negative: int; // Voltage on CP terminal, negative period, corrected for voltage drop on schottky diode [0.1V] (pos=211, name="Control pilot negative", unit=V, dec=1). {AllocGroup="Charge driver", scada}
  control_pilot_status: int; // Status derived from the positive voltage on the CP terminal: 0-standby (12V), 1-connected (9V), 2-charging (6V), 3-ventilation (3V), 4-short circuit (0V). {AllocGroup="Charge driver"}
  control_pilot_plus_error: bool; // Status derived from the positive voltage on the CP terminal: 0-ok, 1-error. {AllocGroup="Charge driver"}
  control_pilot_minus_error: bool; // Status derived from the negative voltage on the CP terminal: 0-ok, 1-error. {AllocGroup="Charge driver"}
  vehicle_connected: bool; // Vehicle connected to the charging station (pos=112, name="Vehicle connected", icon=9). {AllocGroup="Charge driver", scada}
  charging_request: bool; // Vehicle request to deliver energy for charging (pos=113, name="Charging request", icon=9). {AllocGroup="Charge driver", scada}
  charger_status: int; // Current charger status: 0-locked, 1-standby, 2-connected, 3-starting, 4-stopping, 5-charging, 6-error (pos=110, name="Charger status", list=LOCKED|STANDBY|CONNECT|STARTING|STOPPING|CHARGING|ERROR). {AllocGroup="User variables", scada}
  cybro_uptime: long; // Number of operating hours since power-on [h]. {AllocGroup="Cybro system"}
  program_id: int; // Identification number for autodetect. {AllocGroup="Cybro system"}
  program_version: int; // Program version, more and less significant number (pos=201, name="Program version", dec=2). {AllocGroup="Cybro system", scada}
  cybro_nad: long; // Controller A-bus address (pos=200, name="Serial number"). {AllocGroup="Cybro system", scada}
  priority_profile: bool; // Currently active charging profile: 0-economy, 1-priority (pos=100, name="Priority profile", icon=14, action=2, pages=Charger|Devices|Settings). {AllocGroup="User variables", scada}
  priority_timer: int; // Timer for count down priority profile [min] (pos=111, name="Priority timer", unit=min, action=7). {AllocGroup="User variables", scada}
  charging_paused: bool; // Request to temporary stop the charging process (pos=101, name="Pause charging", icon=14, action=2). {AllocGroup="User variables", scada}
  charger_locked: bool; // Charging not allowed. To unlock, swipe rfid card. Rfid reader must be enabled (pos=102, name="Lock charger", icon=14, action=2). {AllocGroup="User variables", scada}
  charging_error: bool; // Indicate that charger is in an error state (pos=115, name="Charging error", icon=10). {AllocGroup="User variables", scada}
  error_code: int; // Set to identify error source: 1-control pilot positive, 2-control pilot negative, 3-RCD sensor, 4-overvoltage, 5-undervoltage, 6-charge with ventilation. {AllocGroup="User variables"}
  output_contactor: bool; // Contactor that delivers energy to the vehicle (pos=114, name="Output contactor", icon=9). {AllocGroup="User variables", scada}
  ventilation_request: bool; // Vehicle requests charging with ventilation. {AllocGroup="Charge driver"}
  three_phase: bool; // Charging station connected to the 3-phase power grid. {AllocGroup="Charge driver"}
  rfid_card_add_req: bool; // Add a new RFID card (pos=341, name="Add new card", icon=8, action=1). {AllocGroup="RFID system", scada}
  rfid_card_del_req: bool; // Delete the last stored RDIF card (pos=342, name="Delete last card", icon=8, action=1). {AllocGroup="RFID system", scada}
  rfid_card_timer: int; // Timeout for adding a new RFID card [s] (pos=343, name="Card timer", unit=s, max=60, bar=1). {AllocGroup="RFID system", scada}
  scan_time_us: long; // Average scan execution time [us]. {AllocGroup="Cybro system"}
  charging_current: int; // Current delivered to the vehicle [0.1A] (pos=120, name="Charging current", unit=A, dec=1, spacer=""). {AllocGroup="Charge driver", scada}
  charging_limit: int; // Maximum charging current, sent to vehicle as pwm signal [0.1A]. {AllocGroup="User variables"}
  remote_current_limit: int; // Maximum charging current, limited by remote operator [%]. Zero means no limit, 1..100 is limit given by percentage of nominal power, 200 means use as much as possible. Press and hold to reset (pos=280, name="Remote limit", unit=%). {AllocGroup="User variables", scada}
  internal_req: bool; // Start one reading cycle with internal meter. {AllocGroup="Power meter"}
  internal_detected: bool; // Indicator that internal power meter is connected (pos=240, name="Internal meter", icon=9). {AllocGroup="Power meter", scada}
  internal_connection: int; // Communication quality, percentage of good communication cycles in last few minutes [%]. {AllocGroup="Power meter"}
  internal_roundtrip: int; // Elapsed time from request to answer [ms]. {AllocGroup="Power meter"}
  internal_voltage_L1: int; // Internal power meter line voltage [V] (pos=241, name="Internal voltage", unit=V). {AllocGroup="Power meter", scada}
  internal_voltage_L2: int; // Internal power meter line voltage [V]. {AllocGroup="Power meter"}
  internal_voltage_L3: int; // Internal power meter line voltage [V]. {AllocGroup="Power meter"}
  internal_current_L1: int; // Internal power meter line current [0.1A]. {AllocGroup="Power meter"}
  internal_current_L2: int; // Internal power meter line current [0.1A]. {AllocGroup="Power meter"}
  internal_current_L3: int; // Internal power meter line current [0.1A]. {AllocGroup="Power meter"}
  rfid_card_number: int; // Total number of stored cards (0..4) (pos=344, name="Number of stored cards"). {AllocGroup="RFID system", scada}
  internal_current: int; // Internal power meter current [0.1A] (pos=242, name="Internal current", unit=A, dec=1). {AllocGroup="Power meter", scada}
  internal_power: int; // Internal power meter power [kW] (pos=243, name="Internal power", unit=kW, dec=1). {AllocGroup="Power meter", scada}
  house_req: bool; // Start one reading cycle with house meter. {AllocGroup="Power meter"}
  house_detected: bool; // Indicator that house power meter is connected (pos=250, name="Household meter", icon=9). {AllocGroup="Power meter", scada}
  house_connection: int; // Communication quality, percentage of good communication cycles in last few minutes [%]. {AllocGroup="Power meter"}
  house_timer: int; // Millisecond counter for communication [ms]. {AllocGroup="Power meter"}
  house_roundtrip: int; // Elapsed time from request to answer [ms]. {AllocGroup="Power meter"}
  house_voltage_L1: int; // House power meter line voltage [V] (pos=251, name="Household voltage", unit=V). {AllocGroup="Power meter", scada}
  house_voltage_L2: int; // House power meter line voltage [V]. {AllocGroup="Power meter"}
  house_voltage_L3: int; // House power meter line voltage [V]. {AllocGroup="Power meter"}
  house_current_L1: int; // House power meter line current [0.1A]. {AllocGroup="Power meter"}
  house_current_L2: int; // House power meter line current [0.1A]. {AllocGroup="Power meter"}
  house_current_L3: int; // House power meter line current [0.1A]. {AllocGroup="Power meter"}
  house_current: int; // Current consumed by the house, including the charger [0.1A] (pos=252, name="Household current", unit=A, dec=1). {AllocGroup="Power meter", scada}
  house_power: int; // Power consumed by the house, including the charger [0.1kW] (pos=253, name="Household power", unit=kW, dec=1). {AllocGroup="Power meter", scada}
  solar_req: bool; // Start one reading cycle with solar meter. {AllocGroup="Power meter"}
  solar_detected: bool; // Indicator that solar power meter is connected (pos=260, name="Solar meter", icon=9). {AllocGroup="Power meter", scada}
  solar_connection: int; // Communication quality, percentage of good communication cycles in last few minutes [%]. {AllocGroup="Power meter"}
  solar_timer: int; // Millisecond counter for communication [ms]. {AllocGroup="Power meter"}
  button_shortpress_req: bool; // The button pressed shortly. {AllocGroup="Device driver"}
  button_longpress_req: bool; // The button pressed and hold. {AllocGroup="Device driver"}
  led_color: int; // LED color: 0-off, 1-red, 2-green, 3-yellow, 4-blue, 5-purple, 6-cyan, 7-white. {AllocGroup="Device driver"}
  led_inverse: int; // LED alternate color: 0-off, 1-red, 2-green, 3-yellow, 4-blue, 5-purple, 6-cyan, 7-white. {AllocGroup="Device driver"}
  led_blinking: int; // LED blinking mode: 0-off, 1-fast, 2-slow, 3-asymetric. {AllocGroup="Device driver"}
  led_error_req: bool; // Request for short red blink. {AllocGroup="Device driver"}
  tick_req: bool; // Request for a very short tick. {AllocGroup="Device driver"}
  beep_req: bool; // Request for a short beep. {AllocGroup="Device driver"}
  buzz_req: bool; // Request for a long beep. {AllocGroup="Device driver"}
  solar_roundtrip: int; // Elapsed time from request to answer [ms]. {AllocGroup="Power meter"}
  charging_start_hour: int; // Time when the charging process is started [hh:mm]. Defined as the moment when the output contactor is turned on. {AllocGroup="Event logger"}
  charging_start_min: int; // Time when the charging process is started [hh:mm]. Defined as the moment when the output contactor is turned on. {AllocGroup="Event logger"}
  remote_current_timer: int; // Timer for count down remote current limit [min]. When timer expires, limit is disabled. Zero means no time limit (pos=281, name="Remote timer", unit=min). {AllocGroup="User variables", scada}
  new_group_address_req: bool; // Create new group address and send to all devices. Devices must be in configuration mode, within 10s from power up (pos=330, name="Send new address", icon=8, action=1, spacer="Radio group"). {AllocGroup="User variables", scada}
  charging_stop_hour: int; // Time when the charging process is stopped [hh:mm]. Defined as the moment when the output contactor is turned off. {AllocGroup="Event logger"}
  charging_stop_min: int; // Time when the charging process is stopped [hh:mm]. Defined as the moment when the output contactor is turned off. {AllocGroup="Event logger"}
  charging_duration: int; // Charging duration [min]. Total time spent with power turned on, excluding inactive periods (pos=122, name="Charging duration", unit=min). {AllocGroup="Event logger", scada}
  charging_energy: int; // Energy transferred in the current charging cycle [0.1kWh] (pos=123, name="Charging energy", unit=kWh, dec=1). {AllocGroup="Event logger", scada}
  charging_average: int; // Average charging current, calculated for the period in which the charging was active [0.1A]. {AllocGroup="Event logger"}
  rcd_sensor_error: bool; // Residual current sensor not connected or defective. Press and hold to reset (pos=230, name="RCD sensor status", icon=11). {AllocGroup="Device driver", scada}
  reset_group_address_req: bool; // Reset own group address to factory default (pos=331, name="Reset to default", icon=8, action=1). {AllocGroup="User variables", scada}
  solar_voltage_L1: int; // Solar power meter line voltage [V] (pos=261, name="Solar voltage", unit=V). {AllocGroup="Power meter", scada}
  solar_voltage_L2: int; // Solar power meter line voltage [V]. {AllocGroup="Power meter"}
  solar_voltage_L3: int; // Solar power meter line voltage [V]. {AllocGroup="Power meter"}
  solar_current_L1: int; // Solar power meter line current [0.1A]. {AllocGroup="Power meter"}
  solar_current_L2: int; // Solar power meter line current [0.1A]. {AllocGroup="Power meter"}
  solar_current_L3: int; // Solar power meter line current [0.1A]. {AllocGroup="Power meter"}
  solar_current: int; // Current produced by the solar power plant [0.1A] (pos=262, name="Solar current", unit=A, dec=1). {AllocGroup="Power meter", scada}
  solar_power: int; // Power produced by the solar power plant [0.1kW] (pos=263, name="Solar power", unit=kW, dec=1). {AllocGroup="Power meter", scada}
  rfid_card_index: int; // Card swipe, index of the recognized card (0..3). {AllocGroup="RFID system"}
  relay_req: bool; // Start one writing cycle with radio relay. {AllocGroup="Power meter"}
  relay_detected: bool; // Indicator that radio relay is connected (pos=270, name="Remote relay", icon=9). {AllocGroup="Power meter", scada}
  relay_connection: int; // Communication quality, percentage of good communication cycles in last few minutes [%]. {AllocGroup="Power meter"}
  relay_timer: int; // Millisecond counter for communication [ms]. {AllocGroup="Power meter"}
  relay_roundtrip: int; // Elapsed time from request to answer [ms]. {AllocGroup="Power meter"}
  charging_power: int; // Power delivered to the vehicle [0.1kW] (pos=121, name="Charging power", unit=kW, dec=1). {AllocGroup="Charge driver", scada}
  proximity_pilot_resistor: int; // Measured value of the resistor connected to PP terminal [Ohm] (pos=220, name="Proximity pilot", unit=Ohm). {AllocGroup="Charge driver", scada}
  relay_output: bool; // Radio relay on/off state (pos=271, name="Remote relay on/off", icon=9, action=2). {AllocGroup="Power meter", scada}
  cable_assembly_current: int; // Maximum current capability of the cable assembly, defined by the resistor on PP terminal [0.1A] (pos=221, name="Proximity pilot cable", unit=A, dec=1). {AllocGroup="Charge driver", scada}
  radio_step: int; // Step counter for communication with radio devices. {AllocGroup="Power meter"}
  rfid_card_req: bool; // Card swipe recognized. Set by rfid system, reset by charger algo. {AllocGroup="RFID system"}
  cybro_temperature AT %IW0020: int; // Measured internal temperature [*0.1C] (pos=203, name="Internal temperature", unit=C, dec=1). {AllocGroup="I/O Variables", scada}
  cybro_power_supply AT %IW0021: int; // Measured power supply voltage [*0.1V]. Measuring range is 0..40V (pos=202, name="Power supply", unit=V, dec=1). {AllocGroup="I/O Variables", scada}
  rtc_min AT %QW0025: int; // Minutes of internal real-time clock (0..59) (pos=321, name="Current time", unit=min, max=59, action=6). {AllocGroup="I/O Variables", scada}
  rtc_hour AT %QW0026: int; // Hours of internal real-time clock (0..59) (pos=320, name="Current time", unit=hour, max=23, action=6, spacer="Real-time clock"). {AllocGroup="I/O Variables", scada}
  rtc_date AT %QW0028: int; // Date of internal real-time clock (1..31) (pos=322, name="Current date", unit=day, min=0, max=31, action=6). {AllocGroup="I/O Variables", scada}
  rtc_month AT %QW0029: int; // Month of internal real-time clock (1..12) (pos=323, name="Current date", unit=month, min=1, max=12, action=6). {AllocGroup="I/O Variables", scada}
  rtc_year AT %QW0030: int; // Year of internal real-time clock (2000..2999) (pos=324, name="Current date", unit=year, min=2020, max=2050, action=6). {AllocGroup="I/O Variables", scada}
  priority_graph: int; // Scaled for scada. {AllocGroup="User variables"}
  connected_graph: int; // Scaled for scada. {AllocGroup="User variables"}
  charging_graph: int; // Scaled for scada. {AllocGroup="User variables"}
  hardware_error_ram: bool; // 64Kb static RAM for retentive variables, tested at system boot (pos=205, name="RAM status", icon=11). {AllocGroup="Cybro system", scada}
  hardware_error_eth: bool; // internal Ethernet controller for A-bus connection, tested at system boot (pos=206, name="ETH status", icon=11). {AllocGroup="Cybro system", scada}
  hardware_error_base: bool; // CPU connection to baseboard, continuously monitored (pos=207, name="Base status", icon=11). {AllocGroup="Cybro system", scada}
  hardware_option_rfm: bool; // radio frequency module, tested during system boot (pos=208, name="RFM status", icon=9). {AllocGroup="Cybro system", scada}
  hardware_option_wifi: bool; // wi-fi module, tested during system boot (pos=209, name="WiFi status", icon=9). {AllocGroup="Cybro system", scada}
  rcd_sensor_trip: bool; // Residual current greater than 6mA detected (pos=231, name="RCD sensor trip", icon=10). {AllocGroup="Device driver", scada}
  socket_req: bool; // Used to send socket to testing device. {AllocGroup="Cybro system"}
var_end;

function main:void; language 'Structured Text';
  function charge_control:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    x: int; // Minute of day.
    ebeg: int; // Economy begin.
    eend: int; // Economy end.
    inside: bool; // Within the interval.
    cmax: int; // Charging maximum [0.1A].
    cmin: int; // Charging minimum [0.1A].
    household: int; // Household consumption [0.1A].
  var_end;

  begin
    /***************************************************************************************************
                                             charger main logic
    ***************************************************************************************************/
    
    /* lock/unlock charger */
    
    if rfid_card_req then
      charger_locked:=not(charger_locked); // lock/unlock with rfid card
      rfid_card_req:=0;
    end_if;
    
    if fn(vehicle_connected or charging_error) and rfid_enable then
      charger_locked:=1; // lock charger when vehicle is disconnected
    end_if;
    
    if fn(rfid_enable) and charger_locked then
      charger_locked:=0; // unlock charger when rfid is disabled
    end_if;
    
    if fp(rfid_enable) and not(vehicle_connected or charging_error) then
      charger_locked:=1; // lock charger when rfid is enabled
    end_if;
    
    /* start/stop charger */
    
    if button_shortpress_req then
      if not charger_locked and not charging_error then
        charging_paused:=not(charging_paused);
        beep_req:=1;
      end_if;
      button_shortpress_req:=0;
    end_if;
    
    /* economy/priority profile */
    
    if button_longpress_req then
      if not charger_locked and not charging_error then
        priority_profile:=not(priority_profile);
        beep_req:=1;
      end_if;
      button_longpress_req:=0;
    end_if;
    
    /* start/stop charging */
    
    x:=60*rtc_hour+rtc_min; // minute of day
    ebeg:=60*economy_start_hour+economy_start_min; // economy begin
    eend:=60*economy_stop_hour+economy_stop_min; // economy end
    
    /* check if inside the interval */
    if economy_start_hour==0 and economy_start_min==0 then
      inside:=1; // interval not configured
    elsif ebeg<eend then
      inside:=(x>=ebeg and x<eend); // inside the interval
    else
      inside:=(x>=ebeg or x<eend); // inside the interval
    end_if;
    
    /* vehicle connects, economy profile and outside the interval */
    if fp(vehicle_connected) and not(priority_profile) and not(inside) then
      charging_paused:=1; // enter pause state
    end_if;
    
    /* charger unlocks, economy profile and outside the interval */
    if fn(charger_locked) and vehicle_connected and not(priority_profile) and not(inside) then
      charging_paused:=1; // enter pause state
    end_if;
    
    /* interval begins, vehicle connected and economy profile */
    if fp(inside) and vehicle_connected and not(priority_profile) then
      charging_paused:=0; // leave pause state
    end_if;
    
    /* priority profile turns the pause off */
    if fp(priority_profile) then
      charging_paused:=0;
    end_if;
    
    /* pause turns the priority profile off */
    if fp(charging_paused) then
      priority_profile:=0;
    end_if;
    
    /* vehicle disconnect turns the priority and pause off */
    if fn(vehicle_connected) then
      charging_paused:=0;
      priority_profile:=0;
    end_if;
    
    /* charger lock or charger error forces priority and pause off */
    if charger_locked or charging_error then
      charging_paused:=0;
      priority_profile:=0;
    end_if;
    
    /* led status */
    
    case charger_status of
      SLOCKED:   led_color:=CBLUE;
      SSTANDBY:  led_color:=CWHITE;
      SCONNECT:  led_color:=CYELLOW;
      SSTARTING: led_color:=CYELLOW;
      SSTOPPING: led_color:=CGREEN;
      SCHARGING: led_color:=CGREEN;
      SERROR:    led_color:=CRED;
    else
      led_color:=OFF;
    end_case;
    
    if charging_paused then
      led_blinking:=BSLOW; // slow blinking
      led_inverse:=OFF;
    elsif priority_profile then
      led_blinking:=BASYM; // asymetric blinking
      led_inverse:=CPURPLE;
    else
      led_blinking:=OFF; // no blinking
      led_inverse:=OFF;
    end_if;
    
    /* priority timer */
    
    if fp(priority_profile) then
      priority_timer:=priority_duration; // reload timer
    elsif fn(priority_profile) then
      priority_timer:=0; // disable timer
    elsif priority_timer>0 and output_contactor then
      priority_timer:=priority_timer-fp(rtc_sec==0); // countdown in minutes
      if priority_timer==0 then
        priority_profile:=0;
      end_if;
    end_if;
    
    /* remote relay */
    
    if fp(priority_profile and charging_request) then
      relay_output:=1;
    end_if;
    
    if fn(priority_profile and charging_request) then
      relay_output:=0;
    end_if;
    
    /* remote timer */
    
    if remote_current_timer>0 then
      remote_current_timer:=remote_current_timer-fp(rtc_sec==0); // countdown in minutes
      if remote_current_timer==0 then
        remote_current_limit:=0; // remove limit
      end_if;
    end_if;
    
    /* current limit */
    
    household:=house_current-charging_current; // household consumption
    if household<0 then household:=0; end_if;
    
    if not vehicle_connected then
      charging_limit:=0; // limit is zero until vehicle is connected
    elsif priority_profile then
      /* priority profile */
      charging_limit:=power_grid_limit+solar_current-household; // use all available current
    else
      /* economy profile */
      if economy_current_limit==0 or remote_current_limit==200 then
        charging_limit:=power_grid_limit+solar_current-household; // use all available current
      else
        cmin:=solar_current-household; // lower limit, use all available solar
        cmax:=power_grid_limit+solar_current-household; // upper limit, nominal grid current
        if economy_current_limit>cmax then
          charging_limit:=cmax; // don't go above the maximum
        elsif economy_current_limit<cmin then
          charging_limit:=cmin; // don't go below the minimum
        else
          charging_limit:=economy_current_limit; // charge on configured limit
        end_if;
      end_if;
    end_if;
    
    if remote_current_limit>0 and remote_current_limit<100 then
      if charging_limit>int(long(remote_current_limit)*long(power_grid_limit)/100) then
        charging_limit:=int(long(remote_current_limit)*long(power_grid_limit)/100); // limited by remote operator [%]
      end_if;
    end_if;
    
    if cable_assembly_current<>0 and charging_limit>cable_assembly_current then
      charging_limit:=cable_assembly_current; // limited by charger cable
    end_if;
    
    /* collecting error flags */
    
    if control_pilot_plus_error then
      if not charging_error then
        error_code:=ERRPOS; // control pilot positive side
        charging_error:=1;
      end_if;
    end_if;
    
    if control_pilot_minus_error then
      if not charging_error then
        error_code:=ERRNEG; // control pilot negative side
        charging_error:=1;
      end_if;
    end_if;
    
    if rcd_sensor_trip then
      if not charging_error then
        error_code:=ERRRCD; // rcd sensor trip
        charging_error:=1;
      end_if;
    end_if;
    
    if overvoltage_limit<>0 then
      if internal_voltage_L1>overvoltage_limit or
         internal_voltage_L2>overvoltage_limit or
         internal_voltage_L3>overvoltage_limit then
        if not charging_error then
          error_code:=ERROVER; // overvoltage limit
          charging_error:=1;
        end_if;
      end_if;
    end_if;
    
    if undervoltage_limit<>0 then
      if (internal_voltage_L1>0 and internal_voltage_L1<undervoltage_limit) or
         (internal_voltage_L2>0 and internal_voltage_L2<undervoltage_limit) or
         (internal_voltage_L3>0 and internal_voltage_L3<undervoltage_limit) then
        if not charging_error then
          error_code:=ERRUNDER; // undervoltage limit
          charging_error:=1;
        end_if;
      end_if;
    end_if;
    
    if ventilation_request and not ventilation_available then
      if not charging_error then
        error_code:=ERRVENT; // charging with ventilation
        charging_error:=1;
      end_if;
    end_if;
    
    /* scaled scada variables */
    
    connected_graph:=vehicle_connected*20; // scada binary
    charging_graph:=output_contactor*20; // scada binary
    
    if priority_duration<>0 then
      priority_graph:=(priority_timer*100)/priority_duration; // scada analog
    else
      priority_graph:=priority_profile*30; // scada binary
    end_if;
    
  end;
  function state_machine:void; language 'Structured Text';
  // AllocGroupList="Charge control", "Constants", "User Variables"
  var static
    state_timer: long; // Timer for all state changes [ms]. {AllocGroup="Charge control"}
  var_end;

  var constant
    TSHORT = 500; // Delay to slow down short operations [ms]. {AllocGroup="Constants"}
    TSTART = 2000; // Delay from start charging request to turning the output contactor on [ms]. {AllocGroup="Constants"}
    TNORSP = 6000; // Delay to turn the contactor off when vehicle does not respond to stop charging request [ms]. {AllocGroup="Constants"}
    TCOFF = 50; // Minimum delay from stop charging request to turning the output contactor off [ms].
    TERROR = 15000; // Duration of the error state [ms]. {AllocGroup="Constants"}
    TREADY = 500; // Delay from turning the +12V on to getting the valid control pilot voltage [ms].
  var_end;

  begin
    /***************************************************************************************************
                                          charger state machine
    ***************************************************************************************************/
    
    /* charger state machine */
    
    /* locked */
    if charger_status==SLOCKED then
    
      pwm_control:=PWM_OFF; // pwm stopped
      output_contactor:=0; // contactor off
    
      if not charger_locked then
        charger_status:=SSTANDBY; // charger unlocked
      end_if;
    
    /* standby */
    elsif charger_status==SSTANDBY then
    
      pwm_control:=PWM_OFF; // pwm stopped
      output_contactor:=0; // contactor off
    
      if charger_locked then
        charger_status:=SLOCKED; // charger locked
      elsif vehicle_connected then // 12V->9V
        state_timer:=TSHORT;
        charger_status:=SCONNECT; // vehicle connected
      end_if;
    
    /* connected */
    elsif charger_status==SCONNECT then
    
      pwm_control:=PWM_OFF; // pwm stopped
      output_contactor:=0; // contactor off
    
      if state_timer==0 then
        if charger_locked then
          charger_status:=SLOCKED; // charger locked
        elsif not vehicle_connected then // 9V->12V
          charger_status:=SSTANDBY; // vehicle disconnected
        elsif not charging_paused then
          state_timer:=TSHORT;
          charger_status:=SSTARTING; // start charging
        end_if;
      end_if;
    
    /* starting */
    elsif charger_status==SSTARTING then
    
      pwm_control:=PWM_ON; // start pwm
      output_contactor:=0; // contactor off
    
      if state_timer==0 then
        if charger_locked then
          charger_status:=SLOCKED; // charger locked
        elsif charging_paused then
          state_timer:=TSHORT;
          charger_status:=SCONNECT; // charging paused
        elsif not vehicle_connected then // 9V->12V
          state_timer:=TSHORT;
          charger_status:=SSTANDBY; // vehicle disconnected
        elsif charging_request then // 9V->6V
          state_timer:=TSTART;
          charger_status:=SCHARGING; // start charging
        end_if;
      end_if;
    
    /* stopping */
    elsif charger_status==SSTOPPING then
    
      pwm_control:=PWM_OFF; // stop pwm, contactor is still on
    
      if not charging_request and state_timer<TNORSP-TCOFF then // 6V->9V
        state_timer:=TSHORT;
        charger_status:=SCONNECT; // charging stopped by vehicle
      elsif state_timer==0 then
        state_timer:=TSHORT;
        charger_status:=SCONNECT; // charging stopped by timeout
      elsif not(charger_locked or charging_paused) then
        charger_status:=SCHARGING; // return to charging
      end_if;
    
    /* charging */
    elsif charger_status==SCHARGING then
    
      if state_timer==0 then
        pwm_control:=PWM_ON; // pwm running
        output_contactor:=1; // contactor on
      end_if;
    
      if charger_locked or charging_paused then
        state_timer:=TNORSP;
        charger_status:=SSTOPPING; // charging stopped by charger
      elsif not charging_request then // 6V->9V
        state_timer:=TSHORT;
        charger_status:=SCONNECT; // charging stopped by vehicle
      end_if;
    
    /* error */
    else
    
      pwm_control:=PWM_ERR; // error -12V
      output_contactor:=0; // contactor off
    
      if state_timer<TREADY then
        pwm_control:=PWM_OFF; // prepare to get vehicle status before the error state is finished
      end_if;
    
      if state_timer==0 then
        error_code:=0; // clear source
        charging_error:=0; // clear status
        charger_status:=SSTANDBY; // restart to standby
      end_if;
    end_if;
    
    /* error collector */
    
    if charging_error and charger_status>=SSTANDBY and charger_status<=SCHARGING then
      state_timer:=TERROR;
      charger_status:=SERROR; // go to error state
    end_if;
    
    /* transition timer */
    
    if state_timer>scan_time then state_timer:=state_timer-scan_time; else state_timer:=0; end_if; // countdown [ms]
    
  end;
  function device_driver:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var static
    button_timer: int; // Timer for short/long press.
    led_timer: int; // Timer for LED blinking.
    err_timer: int; // Timer for LED error. {AllocGroup="User variables"}
    beep_timer: int; // Timer for beeper sound.
    rcd_step_counter: int; // RCD sensor state machine [100ms].
    rcd_filter_timer: int; // Timer for filtering ix03 and ix04 digital inputs.
    cybro_ix03_old: bool;
    cybro_ix04_old: bool;
    ix03_filtered: bool;
    ix04_filtered: bool;
  var_end;

  var
    led_period: int;
    led_change: int;
  var_end;

  begin
    /***************************************************************************************************
                                                  device driver
    ***************************************************************************************************/
    
    /* button short/long press */
    
    if cybro_ix00 then // button pressed
      button_timer:=button_timer+scan_time; // count up [ms]
      if fp(button_timer>=1000) then // longpress treshold [ms]
        button_longpress_req:=1;
      end_if;
    elsif button_timer>0 then // button released
      if button_timer<1000 then
        button_shortpress_req:=1;
      end_if;
      button_timer:=0; // reset
    end_if;
    
    /* led blinking */
    
    case led_blinking of
      OFF:   led_period:=   0; led_change:=  1; // off
      BFAST: led_period:= 250; led_change:=125; // fast
      BSLOW: led_period:=1000; led_change:=500; // slow
      BASYM: led_period:=1000; led_change:=850; // asymetric
    end_case;
    
    if led_period==0 then
      led_timer:=0;
    else
      led_timer:=(led_timer+scan_time)%led_period; // count up [ms]
    end_if;
    
    if led_error_req then
      err_timer:=1000;
      led_error_req:=0;
    end_if;
    
    if err_timer>scan_time then err_timer:=err_timer-scan_time; else err_timer:=0; end_if; // countdown [ms]
    
    if err_timer>0 then
      cybro_qx01:=(CRED & 1)<>0; // red led
      cybro_qx02:=(CRED & 2)<>0; // green led
      cybro_qx03:=(CRED & 4)<>0; // blue led
    elsif led_timer<led_change then
      cybro_qx01:=(led_color & 1)<>0; // red led
      cybro_qx02:=(led_color & 2)<>0; // green led
      cybro_qx03:=(led_color & 4)<>0; // blue led
    else
      cybro_qx01:=(led_inverse & 1)<>0; // red led
      cybro_qx02:=(led_inverse & 2)<>0; // green led
      cybro_qx03:=(led_inverse & 4)<>0; // blue led
    end_if;
    
    /* beeper */
    
    if tick_req then
      cybro_qx07:=1;
      beep_timer:=6; // milliseconds
      tick_req:=0;
    elsif beep_req then
      cybro_qx07:=1;
      beep_timer:=40; // milliseconds
      beep_req:=0;
    elsif buzz_req then
      cybro_qx07:=1;
      beep_timer:=1000; // milliseconds
      buzz_req:=0;
    end_if;
    
    if beep_timer>scan_time then
      beep_timer:=beep_timer-scan_time; // countdown [ms]
    else
      beep_timer:=0;
      cybro_qx07:=0;
    end_if;
    
    /* residual current detection */
    /* test output qx6=0: 5V; qx6=1: 0V */
    /* trip signal 0V: ix3=1, ix4=1; 2.5V: ix3=1, ix4=0; 5V: ix3=0, ix4=0 */
    
    if cybro_ix03<>cybro_ix03_old or cybro_ix04<>cybro_ix04_old then
      /* one or both inputs changed, reload timer */
      cybro_ix03_old:=cybro_ix03;
      cybro_ix04_old:=cybro_ix04;
      rcd_filter_timer:=200; // ms
    elsif rcd_filter_timer>0 then
      /* timer countdown [ms] */
      if rcd_filter_timer>scan_time then
        rcd_filter_timer:=rcd_filter_timer-scan_time;
      else
        rcd_filter_timer:=0;
      end_if;
    else
      /* time expired, inputs are stable */
      ix03_filtered:=cybro_ix03;
      ix04_filtered:=cybro_ix04;
    end_if;
    
    if rcd_step_counter<100 then
      /* self test phase, use unfiltered inputs */
      if fp(clock_10ms) then
        case rcd_step_counter of
           0: cybro_qx06:=0; // 0ms, test output to 5V
          20: cybro_qx06:=1; // 200ms, test output to 0V
          40: cybro_qx06:=0; // 400ms, test output to 5V
        end_case;
        case rcd_step_counter of
          22: if not(cybro_ix03==1 and cybro_ix04==0) then rcd_sensor_error:=1; end_if; // 220ms, test point 1 (2.5V)
          35: if not(cybro_ix03==0 and cybro_ix04==0) then rcd_sensor_error:=1; end_if; // 350ms, test point 2 (5V)
          45: if not(cybro_ix03==1 and cybro_ix04==0) then rcd_sensor_error:=1; end_if; // 450ms, test point 3 (2.5V)
        end_case;
        rcd_step_counter:=rcd_step_counter+1;
      end_if;
    else
      /* normal operation, use filtered inputs */
      rcd_sensor_trip:=(ix03_filtered==0 and ix04_filtered==0); // residual current detected (5V)
      rcd_sensor_error:=rcd_sensor_error or (ix03_filtered==1 and ix04_filtered==1); // sensor malfunction (0V)
    end_if;
    
    /* energy output */
    
    cybro_qx00:=output_contactor; // energy output contactor
    
  end;
  function charge_driver:void; language 'Structured Text';
  // AllocGroupList="User variables", "Charge control", "Constants"
  var static
    iw13_filt: int; // Analog input filtered [mV]. {AllocGroup="User variables"}
    iw14_filt: int; // Analog input filtered [mV]. {AllocGroup="Charge control"}
    iw15_filt: int; // Analog input filtered [mV]. {AllocGroup="Charge control"}
    plus_timer: int; default=1000; // Timer for test delay until the measurement is stabilized [ms].
    minus_timer: int; default=1000; // Timer for test delay until the measurement is stabilized [ms].
    iw13_steady: bool; // Measurement stabilized.
  var_end;

  var constant
    FILT = 10; // Filter constant for analog inputs. {AllocGroup="Constants"}
    TNEG = 100; // Treshold for negative voltage on control pilot [0.1V].
  var_end;

  var
    delta: int; // Temporary difference for digital filter.
  var_end;

  begin
    /***************************************************************************************************
                                           charge adapter driver
      hardware
    
      int cybro_qw12 - pwm output 0..100%
      int cybro_iw13 - analog input, CP positive voltage [mV]
      int cybro_iw14 - analog input, CP negative voltage [mV]
      int cybro_iw15 - analog input, PP voltage [mV]
    
      input parameters
    
      int pwm_control - vehicle charging control: 0-stop (+12V), 1-start (pwm output), 2-error (-12V)
      int charging_limit - maximum current available for charging [0.1A]
    
      output parameters
    
      bit vehicle_connected - vehicle connected to the charging station
      bit charging_request - vehicle ready to be charged
      bit ventilation_request - vehicle requests charging with ventilation
      int cable_assembly_current - cable current capability, defined by the PP resistor [0.1A]
    ***************************************************************************************************/
    
    /* initialize */
    
    cybro_io13_mode:=4; // analog input 0..10V
    cybro_io14_mode:=4; // analog input 0..10V
    cybro_io15_mode:=4; // analog input 0..10V
    
    analog_filter:=OFF;
    pulse_train_frequency:=1000; // 1kHz output
    
    /* filter analog measurements */
    
    delta:=(cybro_iw13-iw13_filt)*fp(clock_10ms); // once in 10ms
    if    delta>1000 or delta<-1000 then iw13_filt:=iw13_filt+delta; iw13_steady:=0; // step on large change
    elsif delta>FILT or delta<-FILT then iw13_filt:=iw13_filt+delta/FILT; iw13_steady:=0; // exponential approach
    elsif delta<>0                  then iw13_filt:=iw13_filt+(delta>0)-(delta<0); iw13_steady:=1; // linear finish
    end_if;
    
    delta:=(cybro_iw14-iw14_filt)*fp(clock_10ms); // once in 10ms
    if    delta>1000 or delta<-1000 then iw14_filt:=iw14_filt+delta; // step on large change
    elsif delta>FILT or delta<-FILT then iw14_filt:=iw14_filt+delta/FILT; // exponential approach
    elsif delta<>0                  then iw14_filt:=iw14_filt+(delta>0)-(delta<0); // linear finish
    end_if;
    
    delta:=(cybro_iw15-iw15_filt)*fp(clock_10ms); // once in 10ms
    if    delta>1000 or delta<-1000 then iw15_filt:=iw15_filt+delta; // step on large change
    elsif delta>FILT or delta<-FILT then iw15_filt:=iw15_filt+delta/FILT; // exponential approach
    elsif delta<>0                  then iw15_filt:=iw15_filt+(delta>0)-(delta<0); // linear finish
    end_if;
    
    if iw13_steady then
      control_pilot_positive:=iw13_filt/100+3; // filtered and adjusted +0.3V for schottky diode [0.1V]
    end_if;
    
    control_pilot_negative:=iw14_filt/100+3; // filtered and adjusted +0.3V for schottky diode [0.1V]
    
    /* control pilot pwm output */
    
    if pwm_control==PWM_OFF then // charging disabled (+12V)
      pwm_output:=100; // off
    elsif pwm_control==PWM_ON then // charging enabled
      if    charging_limit<60   then pwm_output:=100; // off
      elsif charging_limit<=504 then pwm_output:=charging_limit/6; // Imax=pwm*0.6A (6..50.4A, 10..84%)
      elsif charging_limit<=800 then pwm_output:=charging_limit/25+64; // Imax=(pwm-64)*2.5A (50.5..80A, 84..96%)
      else                           pwm_output:=96; // max
      end_if;
    elsif pwm_control==PWM_ERR then // charging error (-12V)
      pwm_output:=0;
    end_if;
    
    /* pwm output, workaround for 100% */
    
    if pwm_output<100 then
      cybro_qx12:=0;
      cybro_qw12:=pwm_output;
      cybro_io12_mode:=11; // pwm output
    else
      cybro_qx12:=1;
      cybro_qw12:=100;
      cybro_io12_mode:=2; // binary output
    end_if;
    
    /* control pilot status */
    
    if    control_pilot_positive>=(120+90)/2+2                                         then control_pilot_status:=CP12V; // standby
    elsif control_pilot_positive>= (90+60)/2+2 and control_pilot_positive<(120+90)/2-2 then control_pilot_status:=CP9V;  // vehicle detected
    elsif control_pilot_positive>= (60+30)/2+2 and control_pilot_positive< (90+60)/2-2 then control_pilot_status:=CP6V;  // charging
    elsif control_pilot_positive>= (30+ 0)/2+2 and control_pilot_positive< (60+30)/2-2 then control_pilot_status:=CP3V;  // ventilation
    elsif                                          control_pilot_positive< (30+ 0)/2-2 then control_pilot_status:=CP0V;  // short circuit
    end_if;
    
    vehicle_connected:=(control_pilot_status==CP9V or control_pilot_status==CP6V or control_pilot_status==CP3V); // vehicle connected
    charging_request:=(control_pilot_status==CP6V or control_pilot_status==CP3V); // vehicle requests charging
    ventilation_request:=(control_pilot_status==CP3V); // vehicle requests charging with ventilation
    
    /* positive side error */
    
    if pwm_output==0 then plus_timer:=1000; end_if; // keep timer loaded [ms] until pwm is running or fixed at +12V
    if plus_timer>scan_time then plus_timer:=plus_timer-scan_time; else plus_timer:=0; end_if; // countdown [ms]
    control_pilot_plus_error:=control_pilot_status==CP0V and plus_timer==0; // illegal value for positive voltage
    
    /* negative side error */
    
    if pwm_output==100 then minus_timer:=1000; end_if; // keep timer loaded [ms] until pwm is running or fixed at -12V
    if minus_timer>scan_time then minus_timer:=minus_timer-scan_time; else minus_timer:=0; end_if; // countdown [ms]
    control_pilot_minus_error:=control_pilot_negative<TNEG and minus_timer==0; // treshold for negative voltage [0.1V]
    
    /* proximity pilot */
    
    if iw15_filt>10000 then
      proximity_pilot_resistor:=9999; // open
    else
      proximity_pilot_resistor:=int((3300*long(iw15_filt))/(12000-iw15_filt)); // Rc=(3k3*U)/(12-U)
    end_if;
    
    if    proximity_pilot_resistor<50   then cable_assembly_current:=0;   // short
    elsif proximity_pilot_resistor<150  then cable_assembly_current:=630; // Rc=100
    elsif proximity_pilot_resistor<330  then cable_assembly_current:=320; // Rc=220
    elsif proximity_pilot_resistor<1000 then cable_assembly_current:=200; // Rc=680
    elsif proximity_pilot_resistor<2700 then cable_assembly_current:=130; // Rc=1k5
    else                                     cable_assembly_current:=130; // open
    end_if;
    
  end;
  function internal_meter:void; language 'Structured Text';
  // AllocGroupList="Power meter", "Internal meter", "User Variables"
  var static
    reply_timer: int; // Millisecond counter for communication [ms]. {AllocGroup="Power meter"}
    modbus_step: int; // Modbus state machine. {AllocGroup="Internal meter"}
  var_end;

  var
    crc: int; // Temporary crc value.
  var_end;

  begin
    /***************************************************************************************************
                                           internal power meter
    ***************************************************************************************************/
    
    com_select(3); // select COM port
    
    /* Eastron SDM630-Modbus V2, addr=1, 9600 8n1 */
    
    if modbus_step==0 and internal_req then
      // send request
      //            device address
      //             |  function code (4-read input register)
      //             |  |  starting address hi/lo
      //             |  |  |     number of registers hi/lo
      //             |  |  |     |     crc lo/hi
      //             |  |  |     |     |
      //             0  1  2  3  4  5  6  7
      dprns(0,0,0,'\01\04\00\00\00\12\00\00'); // first 9 parameters (18 registers, 30001..30017)
      crc:=crc16(6); // calculate crc
      tx_bufwr(6,crc and 16#FF); // lo byte
      tx_bufwr(7,crc shr 8); // hi byte
      tx_start(8); // number of bytes to send
      internal_req:=0;
      reply_timer:=0;
      modbus_step:=modbus_step+1;
    elsif modbus_step==1 and not(tx_active()) then
      // when transmit is finished, start receive
      dclr(0); // erase buffer
      rx_start(0,0,0,100,20); // receive by timeout
      modbus_step:=modbus_step+1;
    elsif modbus_step==2 and not(rx_active()) then
      // receive finished
      if rx_bufrd(0)==1 and rx_bufrd(1)==4 and rx_bufrd(2)==36 then
        // valid response received
        //   device address
        //   |  function code (4-read input register)
        //   |  |  number of received data bytes
        //   |  |  |  received data hi/lo
        //   |  |  |  |               received crc lo/hi
        //   |  |  |  |               |
        //   0  1  2  3  4  5  6      x  x
        // \01\04\24\xx\xx\xx\xx\...\xx\xx
        internal_voltage_L1 :=read_answer(30001,0); // V
        internal_voltage_L2 :=read_answer(30003,0); // V
        internal_voltage_L3 :=read_answer(30005,0); // V
        internal_current_L1 :=abs(read_answer(30007,1)); // 0.1A
        internal_current_L2 :=abs(read_answer(30009,1)); // 0.1A
        internal_current_L3 :=abs(read_answer(30011,1)); // 0.1A
        internal_power      :=abs(read_answer(30013,-2)+read_answer(30015,-2)+read_answer(30017,-2)); // 0.1kW
        internal_detected   :=1;
        internal_roundtrip  :=reply_timer; // ms
        if internal_connection<100 then internal_connection:=internal_connection+(100-internal_connection)/10+1; end_if;
      else
        // receive error
        internal_voltage_L1 :=0;
        internal_voltage_L2 :=0;
        internal_voltage_L3 :=0;
        internal_current_L1 :=0;
        internal_current_L2 :=0;
        internal_current_L3 :=0;
        internal_power      :=0;
        internal_detected   :=0;
        internal_roundtrip  :=0;
        if internal_connection>0 then internal_connection:=internal_connection-internal_connection/10-1; end_if;
      end_if;
      three_phase:=(internal_voltage_L1>0 and internal_voltage_L2>0 and internal_voltage_L3>0);
      charging_current:=internal_current_L1;
      charging_power:=internal_power;
      modbus_step:=modbus_step+1;
    elsif modbus_step>=3 then
      modbus_step:=0;
    end_if;
    
    reply_timer:=reply_timer+scan_time; // millisecond counter
    
  end;
  function radio_system:void; language 'Structured Text';
  begin
    
    com_select(4); // select RFM port
    
    /* radio timing */
    
    internal_req:=fp(clock_1s); // internal meter also
    
    if fp(clock_1s and fast_wireless_cycle==0) or fp(clock_100ms and fast_wireless_cycle==1) then
      case radio_step of
        0: house_req:=1; // t=0
        2: solar_req:=1; // t=200ms/2s
        4: relay_req:=1; // t=400ms/4s
      end_case;
      radio_step:=(radio_step+1)%10;
    end_if;
    
    // initialize radio interface on power up
    
    if first_scan then
      rx_start(0,0,0,0,0);
    end_if;
    
    // reset own group address to factory default
    
    if reset_group_address_req then
      /* reset address */
      group_address:=0; // zero means factory default
      ee_write_magic:=31415;
      ee_write_req:=1;
      rx_start(0,0,0,0,0); // switch to default address
      reset_group_address_req:=0;
    end_if;
    
    // create new group address and send to all devices
    
    if new_group_address_req then
      /* create new address */
      group_address:=rnd32();
      ee_write_magic:=31415;
      ee_write_req:=1;
      rx_start(0,0,int(group_address>>16),int(group_address),0); // switch to new address
      /* send address */
      dprnc(0,0,0,int((group_address>>24) and 16#FF));
      dprnc(0,1,0,int((group_address>>16) and 16#FF));
      dprnc(0,2,0,int((group_address>>8) and 16#FF));
      dprnc(0,3,0,int(group_address and 16#FF));
      tx_bufwr(64,1); // message type (1-address)
      rx_start(0,0,0,0,0); // temporary switch to default address
      tx_start(4); // number of bytes to send
      new_group_address_req:=0;
    end_if;
    
  end;
  function house_meter:void; language 'Structured Text';
  // AllocGroupList="Power meter", "User variables"
  var static
    reply_timer: int; // Millisecond counter for communication [ms]. {AllocGroup="Power meter"}
    modbus_step: int; // Modbus state machine. {AllocGroup="User variables"}
  var_end;

  var
    crc: int; // Temporary crc value.
  var_end;

  begin
    /***************************************************************************************************
                                             house power meter
    ***************************************************************************************************/
    
    com_select(4); // select RFM port
    
    if modbus_step==0 and house_req then
      // send request
      //            device address
      //             |  function code (4-read input register)
      //             |  |  starting address hi/lo
      //             |  |  |     number of registers hi/lo
      //             |  |  |     |     crc lo/hi
      //             |  |  |     |     |
      //             0  1  2  3  4  5  6  7
      dprns(0,0,0,'\01\04\00\00\00\12\00\00'); // first 9 parameters (18 registers, 30001..30017)
      crc:=crc16(6); // calculate crc
      tx_bufwr(6,crc and 16#FF); // lo byte
      tx_bufwr(7,crc shr 8); // hi byte
      tx_bufwr(64,2); // message type (2-modbus)
      tx_start(8); // number of bytes to send
      house_req:=0;
      reply_timer:=0;
      modbus_step:=modbus_step+1;
    elsif modbus_step==1 and tx_active()==0 then
      // when transmit is finished, start receive
      dclr(0); // erase buffer
      rx_start(0,0,int(group_address>>16),int(group_address),150); // receive by timeout
      modbus_step:=modbus_step+1;
    elsif modbus_step==2 and not(rx_active()) then
      // receive finished
      if rx_bufrd(0)==1 and rx_bufrd(1)==4 and rx_bufrd(2)==36 and rx_bufrd(64)==2 then
        // valid response received
        //   device address
        //   |  function code (4-read input register)
        //   |  |  number of received data bytes
        //   |  |  |  received data hi/lo
        //   |  |  |  |               received crc lo/hi
        //   |  |  |  |               |
        //   0  1  2  3  4  5  6      x  x
        // \01\04\24\xx\xx\xx\xx\...\xx\xx
        house_voltage_L1 :=read_answer(30001,0); // V
        house_voltage_L2 :=read_answer(30003,0); // V
        house_voltage_L3 :=read_answer(30005,0); // V
        house_current_L1 :=read_answer(30007,1); // 0.1A
        house_current_L2 :=read_answer(30009,1); // 0.1A
        house_current_L3 :=read_answer(30011,1); // 0.1A
        house_current    :=max(house_current_L1,house_current_L2,house_current_L3); // 0.1A
        house_power      :=abs(read_answer(30013,-2)+read_answer(30015,-2)+read_answer(30017,-2)); // 0.1kW
        house_detected   :=1;
        house_roundtrip  :=reply_timer; // ms
        if house_connection<100 then house_connection:=house_connection+(100-house_connection)/10+1; end_if;
      else
        // receive error
        house_voltage_L1 :=0;
        house_voltage_L2 :=0;
        house_voltage_L3 :=0;
        house_current_L1 :=0;
        house_current_L2 :=0;
        house_current_L3 :=0;
        house_current    :=0;
        house_power      :=0;
        house_detected   :=0;
        house_roundtrip  :=0;
        if house_connection>0 then house_connection:=house_connection-house_connection/10-1; end_if;
      end_if;
      modbus_step:=modbus_step+1;
    elsif modbus_step>=3 then
      modbus_step:=0;
    end_if;
    
    reply_timer:=reply_timer+scan_time; // millisecond counter
    
  end;
  function solar_meter:void; language 'Structured Text';
  // AllocGroupList="Power meter", "Internal meter", "User Variables"
  var static
    reply_timer: int; // Millisecond counter for communication [ms]. {AllocGroup="Power meter"}
    modbus_step: int; // Modbus state machine. {AllocGroup="Internal meter"}
  var_end;

  var
    crc: int; // Temporary crc value.
  var_end;

  begin
    /***************************************************************************************************
                                             solar power meter
    ***************************************************************************************************/
    
    com_select(4); // select RFM port
    
    if modbus_step==0 and solar_req then
      // send request
      //            device address
      //             |  function code (4-read input register)
      //             |  |  starting address hi/lo
      //             |  |  |     number of registers hi/lo
      //             |  |  |     |     crc lo/hi
      //             |  |  |     |     |
      //             0  1  2  3  4  5  6  7
      dprns(0,0,0,'\02\04\00\00\00\12\00\00'); // first 9 parameters (18 registers, 30001..30017)
      crc:=crc16(6); // calculate crc
      tx_bufwr(6,crc and 16#FF); // lo byte
      tx_bufwr(7,crc shr 8); // hi byte
      tx_bufwr(64,2); // message type (2-modbus)
      tx_start(8); // number of bytes to send
      solar_req:=0;
      reply_timer:=0;
      modbus_step:=modbus_step+1;
    elsif modbus_step==1 and tx_active()==0 then
      // when transmit is finished, start receive
      dclr(0); // erase buffer
      rx_start(0,0,int(group_address>>16),int(group_address),150); // receive by timeout
      modbus_step:=modbus_step+1;
    elsif modbus_step==2 and not(rx_active()) then
      // receive finished
      if rx_bufrd(0)==2 and rx_bufrd(1)==4 and rx_bufrd(2)==36 and rx_bufrd(64)==2 then
        // valid response received
        //   device address
        //   |  function code (4-read input register)
        //   |  |  number of received data bytes
        //   |  |  |  received data hi/lo
        //   |  |  |  |               received crc lo/hi
        //   |  |  |  |               |
        //   0  1  2  3  4  5  6      x  x
        // \02\04\24\xx\xx\xx\xx\...\xx\xx
        solar_voltage_L1 :=read_answer(30001,0); // V
        solar_voltage_L2 :=read_answer(30003,0); // V
        solar_voltage_L3 :=read_answer(30005,0); // V
        solar_current_L1 :=read_answer(30007,1); // 0.1A
        solar_current_L2 :=read_answer(30009,1); // 0.1A
        solar_current_L3 :=read_answer(30011,1); // 0.1A
        solar_current    :=solar_current_L1; // 0.1A
        solar_power      :=abs(read_answer(30013,-2)+read_answer(30015,-2)+read_answer(30017,-2)); // 0.1kW
        solar_detected   :=1;
        solar_roundtrip  :=reply_timer; // ms
        if solar_connection<100 then solar_connection:=solar_connection+(100-solar_connection)/10+1; end_if;
      else
        // receive error
        solar_voltage_L1 :=0;
        solar_voltage_L2 :=0;
        solar_voltage_L3 :=0;
        solar_current_L1 :=0;
        solar_current_L2 :=0;
        solar_current_L3 :=0;
        solar_current    :=0;
        solar_power      :=0;
        solar_detected   :=0;
        solar_roundtrip  :=0;
        if solar_connection>0 then solar_connection:=solar_connection-solar_connection/10-1; end_if;
      end_if;
      modbus_step:=modbus_step+1;
    elsif modbus_step>=3 then
      modbus_step:=0;
    end_if;
    
    reply_timer:=reply_timer+scan_time; // millisecond counter
    
  end;
  function wireless_relay:void; language 'Structured Text';
  // AllocGroupList="Power meter", "Internal meter", "User Variables"
  var static
    reply_timer: int; // Millisecond counter for communication [ms]. {AllocGroup="Power meter"}
    modbus_step: int; // Modbus state machine. {AllocGroup="Internal meter"}
  var_end;

  var
    crc: int; // Temporary crc value.
  var_end;

  begin
    /***************************************************************************************************
                                              wireless relay
    ***************************************************************************************************/
    
    // send modbus command to turn the wireless relay on and off
    
    com_select(4); // select RFM port
    
    if modbus_step==0 and relay_req then
      //             device address
      //             |  function code (5-write single coil)
      //             |  |  coil address hi/lo (0000)
      //             |  |  |     write data hi/lo (0000 or FF00)
      //             |  |  |     |     crc lo/hi
      //             |  |  |     |     |
      //             0  1  2  3  4  5  6  7
      dprns(0,0,0,'\C8\05\00\00\00\00\00\00');
      dprnc(0,4,0,16#FF*relay_output); // 0-off, FF-on
      crc:=crc16(6); // calculate crc
      tx_bufwr(6,crc and 16#FF); // lo byte
      tx_bufwr(7,crc shr 8); // hi byte
      tx_bufwr(64,2); // message type (2-modbus)
      tx_start(8); // number of bytes to send
      relay_req:=0;
      reply_timer:=0;
      modbus_step:=modbus_step+1;
    elsif modbus_step==1 and tx_active()==0 then
      // when transmit is finished, start receive
      dclr(0); // erase buffer
      rx_start(0,0,int(group_address>>16),int(group_address),150); // receive by timeout
      modbus_step:=modbus_step+1;
    elsif modbus_step==2 and not(rx_active()) then
      // receive finished
      if rx_bufrd(0)==16#C8 and rx_bufrd(1)==5 and rx_bufrd(64)==2 then
        // valid response received
        //   device address
        //   |  function code (4-read input register)
        //   |  |  coil address hi/lo (0000)
        //   |  |  |     write data hi/lo (0000 or FF00)
        //   |  |  |     |     received crc lo/hi
        //   |  |  |     |     |
        //   0  1  2  3  4  5  6  7
        // \C8\05\00\00\00\00\xx\xx
        relay_detected   :=1;
        relay_roundtrip  :=reply_timer; // ms
        if relay_connection<100 then relay_connection:=relay_connection+(100-relay_connection)/10+1; end_if;
      else
        // receive error
        relay_detected   :=0;
        relay_roundtrip  :=0;
        if relay_connection>0 then relay_connection:=relay_connection-relay_connection/10-1; end_if;
      end_if;
      modbus_step:=modbus_step+1;
    elsif modbus_step>=3 then
      modbus_step:=0;
    end_if;
    
    reply_timer:=reply_timer+scan_time; // millisecond counter
    
  end;
  function rfid_system:void; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    card_id: long;
    message_received: bool;
    msg_size: int;
    msg_valid: bool;
    data_start: int;
    checksum: int;
    new_card: bool;
    i: int;
  var_end;

  begin
    /***************************************************************************************************
                                               rfid system
    ***************************************************************************************************/
    
    com_select(1); // select COM port
    
    card_id:=0;
    message_received:=rx_active()==0;
    
    /* CR-W2 wiegand reader */
    
    // if cr00_id_hi_0<>0 or cr00_id_lo_0<>0 then
    //   card_id:=16#10000*ulong(cr00_id_hi_0)+ulong(cr00_id_lo_0);
    //   cr00_id_hi_0:=0;
    //   cr00_id_lo_0:=0;
    // end_if;
    
    /* Monday Kids 7941E rfid reader, round coil, uart 9600 8n1 */
    
    /*    0    1    2    3    4    5    6    7    8    9 */
    /*  beg  len  type  d4   d3   d2   d1   d0  csum end */
    /* 0x02 0x0A 0x02 0x04 0x14 0x35 0xED 0xA0 0x60 0x03 */ /* Vimar 125kHz #1 */
    /* 0x02 0x0A 0x02 0x04 0x14 0x35 0xED 0xBC 0x7C 0x03 */ /* Vimar 125kHz #2 */
    
    /* RFID wireless reader, square coil, 13.56MHz 125kHz dual frequency, uart 9600 8n1 */
    
    /*    0    1    2    3    4    5    6    7    8 */
    /*  beg  len  type  d3   d2   d1   d0  csum end */
    /* 0x02 0x09 0x02 0x14 0x35 0xED 0xA0 0x67 0x03 */ /* Vimar 125kHz #1 */
    /* 0x02 0x09 0x02 0x14 0x35 0xED 0xBC 0x7B 0x03 */ /* Vimar 125kHz #2 */
    /* 0x02 0x09 0x01 0x1E 0x9C 0xF6 0x15 0x69 0x03 */ /* 13.56 MHz #1 */
    /* 0x02 0x09 0x01 0x63 0x29 0x8F 0xE7 0x2A 0x03 */ /* 13.56 MHz #2 */
    
    if message_received and card_id==0 then
      /* message received */
      msg_size:=rx_count();
      checksum:=0;
      for i:=1 to msg_size-3 do
        checksum:=checksum xor rx_bufrd(i);
      end_for;
    
      /* check that message is valid */
      if rx_bufrd(0)==2 and rx_bufrd(1)==msg_size and rx_bufrd(msg_size-2)==checksum and rx_bufrd(msg_size-1)==3 then
        /* message is valid */
        data_start:=msg_size-6; // position of d3 byte
        for i:=0 to 3 do
          card_id:=(card_id<<8)+rx_bufrd(data_start+i); // start with d3, shift d3..d0, ignore other data bytes
        end_for;
      end_if;
    end_if;
    
    /* GROW GM60 QR code reader, uart 9600 8n1 */
    
    /*    0    1    2    3 */
    /* 0x31 0x32 0x33 0x34 */
    /*   d3   d2   d1   d0 */
    
    if message_received and card_id==0 then
      /* message received */
      msg_size:=rx_count();
      msg_valid:=1;
      for i:=0 to msg_size-1 do
        if rx_bufrd(i)<48 or rx_bufrd(i)>=58 then
          msg_valid:=0; // message contain non-digit character
        end_if;
      end_for;
      /* check that message is valid */
      if msg_valid and msg_size>=4 and msg_size<=10 then
        /* message is valid */
        for i:=0 to msg_size-1 do
          card_id:=card_id*10+rx_bufrd(i)-48; // ascii digits to value
        end_for;
      end_if;
    end_if;
    
    /* data format not recognized */
    
    if message_received and card_id==0 then
      if rx_count()>=4 and rx_bufrd(0)<>0 and rx_bufrd(1)<>0 and rx_bufrd(2)<>0 and rx_bufrd(3)<>0 then
        /* declare error only for non-zero message */
        led_error_req:=1;
        buzz_req:=1;
      end_if;
    end_if;
    
    /* restart receiver */
    
    if message_received then
      dclr(0); // clear buffer
      rx_start(0,0,0,0,50); // restart receiver
    end_if;
    
    /* ************************* card management ************************* */
    
    /* card swiped, rfid enabled */
    
    if rfid_enable and card_id<>0 and rfid_card_timer==0 then
      for i:=0 to NOCARDS-1 do
        if card_id==rfid_card[i] then
          /* card authorized */
          rfid_card_index:=i;
          rfid_card_req:=1;
          beep_req:=1;
        end_if;
      end_for;
      if not rfid_card_req then
        /* unknown card */
        led_error_req:=1;
        buzz_req:=1;
      end_if;
    end_if;
    
    /* card swiped, rfid disabled */
    
    if not rfid_enable and card_id<>0 and rfid_card_timer==0 then
      tick_req:=1;
    end_if;
    
    /* add new card */
    
    if rfid_card_add_req then
      rfid_card_timer:=60; // start opportunity window [s]
      rfid_card_add_req:=0;
    end_if;
    
    if rfid_card_timer>0 then rfid_card_timer:=rfid_card_timer-fp(clock_1s); end_if; // countdown [s]
    
    if card_id<>0 and rfid_card_timer>0 then
      new_card:=1;
      for i:=0 to NOCARDS-1 do
        if card_id==rfid_card[i] then
          new_card:=0; // card already added
        end_if;
      end_for;
      if new_card then
        for i:=1 to NOCARDS-1 do
          rfid_card[NOCARDS-i]:=rfid_card[NOCARDS-i-1]; // shift all cards up
        end_for;
        rfid_card[0]:=card_id;
        ee_write_magic:=31415;
        ee_write_req:=1;
      end_if;
      rfid_card_timer:=0;
      beep_req:=1;
    end_if;
    
    /* delete last card */
    
    if rfid_card_del_req then
      for i:=0 to NOCARDS-2 do
        rfid_card[i]:=rfid_card[i+1]; // shift all cards down
      end_for;
      rfid_card[NOCARDS-1]:=0;
      rfid_card_timer:=0;
      ee_write_magic:=31415;
      ee_write_req:=1;
      rfid_card_del_req:=0;
    end_if;
    
    /* count cards */
    
    rfid_card_number:=0;
    for i:=0 to NOCARDS-1 do
      rfid_card_number:=rfid_card_number+(rfid_card[i]<>0);
    end_for;
    
  end;
  function event_logger:void; language 'Structured Text';
  // AllocGroupList="User variables"
  var static
    charging_cycle: bool; // Active during charging cycle. {AllocGroup="User variables"}
    duration_low_word: int; // Duration counter, low word [s]. {AllocGroup="User variables"}
    energy_low_word: int; // Energy counter, low word [100J]. {AllocGroup="User variables"}
  var_end;

    function new_event:void; language 'Structured Text';
    // AllocGroupList="User Variables"
    var constant
      SIZE = 10;
    var_end;

    var
      i: int;
      src: int;
      dst: int;
    var_end;

    begin
      
      /* scroll table one line down */
      
      for i:=1 to SIZE-1 do
        src:=SIZE-i-1;
        dst:=SIZE-i;
      
        event_start_year[dst] :=event_start_year[src];
        event_start_month[dst]:=event_start_month[src];
        event_start_date[dst] :=event_start_date[src];
        event_start_hour[dst] :=event_start_hour[src];
        event_start_min[dst]  :=event_start_min[src];
      
        event_stop_hour[dst]  :=event_stop_hour[src];
        event_stop_min[dst]   :=event_stop_min[src];
        event_duration[dst]   :=event_duration[src];
      
        event_type[dst]       :=event_type[src];
        event_card[dst]       :=event_card[src];
        event_number[dst]     :=event_number[src];
        event_energy[dst]     :=event_energy[src];
        event_average[dst]    :=event_average[src];
      end_for;
      
      /* reset first row */
      
      event_start_year[0]:=0;
      event_start_month[0]:=0;
      event_start_date[0]:=0;
      event_start_hour[0]:=0;
      event_start_min[0]:=0;
      
      event_stop_hour[0]:=0;
      event_stop_min[0]:=0;
      event_duration[0]:=0;
      
      event_type[0]:=0;
      event_card[0]:=0;
      event_number[0]:=0;
      event_energy[0]:=0;
      event_average[0]:=0;
      
    end;
  begin
    /***************************************************************************************************
                                               event logger
    ***************************************************************************************************/
    
    /* charging cycle events */
    
    if fp(vehicle_connected) then
      charging_start_hour:=0;
      charging_start_min:=0;
      charging_stop_hour:=0;
      charging_stop_min:=0;
      charging_duration:=0;
      charging_energy:=0;
      duration_low_word:=0;
      energy_low_word:=0;
    end_if;
    
    if fp(output_contactor) then
      if not charging_cycle then
        charging_start_hour:=rtc_hour;
        charging_start_min:=rtc_min;
        charging_cycle:=1; // cycle starts when contactor is turned on
      end_if;
    end_if;
    
    if fn(output_contactor) then
      charging_stop_hour:=rtc_hour;
      charging_stop_min:=rtc_min;
    end_if;
    
    if fn(vehicle_connected) then
      charging_cycle:=0; // cycle stops when vehicle is disconnected
    end_if;
    
    charging_cycle_count:=charging_cycle_count+fp(charging_cycle);
    
    /* duration and energy */
    
    if output_contactor and fp(clock_1s) then
      duration_low_word:=duration_low_word+1;
      if duration_low_word>=60 then
        charging_duration:=charging_duration+1;
        duration_low_word:=duration_low_word-60;
      end_if;
    end_if;
    
    if output_contactor and fp(clock_1s) then
      energy_low_word:=energy_low_word+charging_power;
      if energy_low_word>=3600 then
        charging_energy:=charging_energy+1;
        energy_low_word:=energy_low_word-3600;
      end_if;
    end_if;
    
    /* average current */
    
    if charging_duration<10 then
      charging_average:=0;
    else
      charging_average:=int(long(charging_energy)*60000/230/charging_duration); // 0.1kW * 3600s / 230V / 60s -> 0.1A
      if three_phase then charging_average:=charging_average/3; end_if; // single-phase or three-phase
    end_if;
    
    /* event logger */
    
    if fp(charging_cycle) then
      /* begin of charging cycle */
      new_event();
      event_start_year[0]:=rtc_year;
      event_start_month[0]:=rtc_month;
      event_start_date[0]:=rtc_date;
      event_start_hour[0]:=rtc_hour;
      event_start_min[0]:=rtc_min;
      event_type[0]:=1; // normal charging cycle
      event_card[0]:=rfid_card_index*rfid_enable; // 0..3-card used to unlock, 99-PC
      event_number[0]:=charging_cycle_count;
    end_if;
    
    if fn(charging_cycle) then
      if event_type[0]==1 then // charging
        /* end of charging cycle */
        event_stop_hour[0]:=charging_stop_hour;
        event_stop_min[0]:=charging_stop_min;
        event_duration[0]:=charging_duration;
        event_energy[0]:=charging_energy;
        event_average[0]:=charging_average;
      end_if;
    end_if;
    
    if fp(charging_error) then
      if error_code<>event_type[0] then
        new_event();
        /* begin of error state */
        event_start_year[0]:=rtc_year;
        event_start_month[0]:=rtc_month;
        event_start_date[0]:=rtc_date;
        event_start_hour[0]:=rtc_hour;
        event_start_min[0]:=rtc_min;
        event_type[0]:=error_code; // current error
      end_if;
    end_if;
    
    if fn(charging_error) then
      if event_type[0]>1 then // error
        /* end of error state */
        event_stop_hour[0]:=rtc_hour;
        event_stop_min[0]:=rtc_min;
      end_if;
    end_if;
    
  end;
  function init_config:void; language 'Structured Text';
  // AllocGroupList="User variables"
  var static
    safety_pin: bool; // Safety measure against accidental reset. {AllocGroup="User variables"}
    factory_timer: int; // Power on to factory reset [ms]. {AllocGroup="User variables"}
  var_end;

  var
    i: int;
  var_end;

  begin
    
    /* integrity broken, initialize configuration parameters to default */
    
    if ee_integrity_magic<>12345678 and (fn(ee_read_req) or fn(ee_write_req)) then
      power_grid_limit:=320;
      economy_current_limit:=0;
      economy_start_hour:=0;
      economy_start_min:=0;
      economy_stop_hour:=0;
      economy_stop_min:=0;
      priority_duration:=0;
      overvoltage_limit:=0;
      undervoltage_limit:=0;
      ventilation_available:=0;
      fast_wireless_cycle:=0;
      group_address:=0;
    
      rfid_enable:=0;
      for i:=0 to NOCARDS-1 do
        rfid_card[i]:=0;
      end_for;
    
      /* integrity */
      ee_integrity_magic:=12345678;
      ee_write_magic:=31415;
      ee_write_req:=1;
    end_if;
    
    /* integrity broken, restore configuration parameters from eeprom */
    
    if ee_integrity_magic<>12345678 and ee_read_req==0 and ee_write_req==0 then
      ee_read_req:=1;
    end_if;
    
    /* factory reset, hold button and power on */
    
    if first_scan then
      safety_pin:=1; // factory reset possible within first 5 seconds
    elsif clock_10s==0 then
      safety_pin:=0;
    end_if;
    
    if safety_pin then
      if fp(cybro_hardware_id<>0) and cybro_ix00 then
        /* button pressed, start sequence */
        factory_timer:=2500; // [ms]
      elsif factory_timer>0 and not cybro_ix00 then
        /* button released, abort sequence */
        factory_timer:=0;
      elsif factory_timer>scan_time then
        /* countdown */
        factory_timer:=factory_timer-scan_time;
      elsif factory_timer>0 then
        /* erase magic to initiate reset */
        factory_timer:=0;
        priority_profile:=0;
        ee_integrity_magic:=0;
        ee_write_magic:=31415;
        ee_write_req:=1;
        buzz_req:=1;
      end_if;
    end_if;
    
  end;
  function read_answer(register,decimals:int):int; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    index: int;
    value: real;
  var_end;

  begin
    
    /* read buffer from the position specified by register number, convert float to integer and return */
    
    index:=(register-30001)*2+3; // register size 2, first data byte 3
    value:=breal(ulong(rx_bufrd(index))<<24+ulong(rx_bufrd(index+1))<<16+ulong(rx_bufrd(index+2))<<8+ulong(rx_bufrd(index+3)));
    
    case decimals of
     -3: result:=int(value/1000);
     -2: result:=int(value/100);
     -1: result:=int(value/10);
      0: result:=int(value);
      1: result:=int(value*10);
      2: result:=int(value*100);
      3: result:=int(value*1000);
    end_case;
    
  end;
  function crc16(length:int):int; language 'Structured Text';
  // AllocGroupList="User Variables"
  var
    i: int;
    j: int;
    crc: int;
  var_end;

  begin
    
    // function crc16(int length):int;
    //
    // 16-bit cyclic redundancy check, Modbus style (polynomial 0x8005, initial value 0xFFFF, no xor)
    // calculation is executed on the fly, no lookup table is used
    // when time is critical, use algorithm with a precalculated lookup table
    //
    // input
    //   int length - message length
    // global
    //   int buffer[] - message, array of bytes (high byte must be zero)
    // output
    //   int result - calculated crc
    // performance
    //   for a 10-byte message, function is executed in about 60us
    // example
    //   01 02 03 04 05 (5 bytes) --> crc is 0xBB2A
    
    crc:=16#FFFF; // initial value
    
    for i:=0 to length-1 do
      crc:=crc xor tx_bufrd(i);
      for j:=0 to 7 do
        if (crc & 1)<>0 then
          crc:=crc shr 1;
          crc:=crc xor 16#A001; // polynomial in reverse order
        else
          crc:=crc shr 1;
        end_if;
      end_for;
    end_for;
    
    result:=crc;
    
  end;
  function rnd32:long; language 'Structured Text';
  // AllocGroupList="User Variables"
  var static
    seed: long; // pseudo-random seed
  var_end;

  var
    output: long;
  var_end;

  begin
    
    // simple pseudo-random generator
    //
    // output is 32-bit positive integer
    // new value is evaluated in each call
    // algorithm is linear congruential generator, Xn+1:=(a*Xn+c) mod m
    // constants are taken from "Numerical Recipes": m=2^32, a=1664525, c=1013904223
    
    if seed==0 then
      seed:=rtc_hour*rtc_min*rtc_sec*get_serial(); // initial seed
    end_if;
    
    seed:=1664525*seed+1013904223;
    output:=seed xor 16#AA55AA55;
    
    // check for zero bytes
    
    if (output&16#FF000000)==0 then output:=output^16#AA000000; end_if;
    if (output&16#00FF0000)==0 then output:=output^16#00AA0000; end_if;
    if (output&16#0000FF00)==0 then output:=output^16#0000AA00; end_if;
    if (output&16#000000FF)==0 then output:=output^16#000000AA; end_if;
    
    // eliminate negative numbers
    
    if output<0 then output:=-output; end_if;
    
    result:=output;
    
  end;
  function max(x0,x1,x2:int):int; language 'Structured Text';
  begin
    
    /* return the biggest of three numbers */
    
    if x0>=x1 and x0>=x2 then
      result:=x0;
    elsif x1>=x0 and x1>=x2 then
      result:=x1;
    else
      result:=x2;
    end_if;
    
  end;
  function abs(x:int):int; language 'Structured Text';
  begin
    
    // function abs(int x):int;
    //
    // returns absoulte value of the argument
    
    if x>=0 then
      result:=x;
    else
      result:=-x;
    end_if;
    
  end;
begin
  /***************************************************************************************************
                                    electric vehicle charging station
  ***************************************************************************************************/
  
  /* initialization */
  
  program_id:=7607;
  program_version:=127;
  cybro_nad:=get_nad();
  disconnect_inputs:=0;
  
  if first_scan then
    charger_locked:=1;
    reset_counter:=reset_counter+1;
  end_if;
  
  if fn(ee_read_req) and not(rfid_enable) then
    charger_locked:=0;
  end_if;
  
  /* system tasks */
  
  scan_time_us:=1000000/scan_frequency;
  cybro_uptime:=cybro_uptime+fp(rtc_min==0);
  operating_hours:=operating_hours+fp(rtc_min==0);
  
  hardware_error_ram  :=(cybro_hardware_error and 1)<>0;
  hardware_error_eth  :=(cybro_hardware_error and 8)<>0;
  hardware_error_base :=(cybro_hardware_error and 16)<>0;
  hardware_option_rfm :=(cybro_hardware_error and 256)<>0;
  hardware_option_wifi:=(cybro_hardware_error and 512)<>0;
  
  if socket_req==bit(3) then socket_req:=1; end_if; // resend
  
  /* charger modules */
  
  charge_control();
  state_machine();
  device_driver();
  charge_driver();
  
  internal_meter();
  radio_system();
  house_meter();
  solar_meter();
  wireless_relay();
  
  event_logger();
  rfid_system();
  init_config();
  
end;
#CODE_END

#DESCRIPTION_BEGIN
#DESCRIPTION_END

##PROGRAM_END_1

